/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
**  
**	www.kavirElectronic.ir & www.kavirelectronic.ir/eshop
**  	support Team:
**  	www.IranMicro.ir  & www.IranMicro.ir/forum
**	
**	 kavirelectronic.com@gmail.com  
**  	0352-7730313  0352-7734146
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* Includes ------------------------------------------------------------------*/
#include "usually.h"
#include "sdcard.h"
#include "ff.h"			/* FatFs configurations and declarations */
#include "diskio.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
extern uint8_t gImage[];

extern uint8_t VsyncCnt;
volatile unsigned int  bb=1,cc=0;

uint16_t brightness=0,contrast=80;

void COBY_BMP(void);
const unsigned char bmp_tou[54]=
	{
	  0x42,0x4d,0x36,0x18, 0x03,0x00,0x00,0x00,  0x00,0x00,0x36,0x00, 0x00,0x00,0x28,0x00,//16
	  0x00,0x00,0x60,0x01, 0x00,0x00,0x20,0x01,  0x00,0x00,0x01,0x00, 0x10,0x00,0x00,0x00,//32
	  0x00,0x00,0x00,0x18, 0x03,0x00,0x00,0x00,  0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,//48
	  0x00,0x00,0x00,0x00, 0x00,0x00,													 //54
	} ;
SD_CardInfo SDCardInfo;

FATFS fs;            // Work area (file system object) for logical drive  
FIL fsrca;      // file objects 

unsigned char buffera[2];
XCHAR file_name[]="IMG0000.bmp";

FRESULT res;         // FatFs function common result code      
UINT br, bw;         // File R/W count 
unsigned int x,y,val,i=0,m=0,n=0,s=0,k=0;

#define NULL 0

/* Private function prototypes -----------------------------------------------*/
void LED_GPIO_Configuration(void);
void NVIC_Configuration(void);
void RCC_Configuration(void);
void Delay_Ms(uint16_t time);  //ʱ
void Delay_Us(uint16_t time);  //ʱ
/* Private functions ---------------------------------------------------------*/
const char menu[] =
   "\n\r"
   "+******************** ſ  ********************+\n\r"
   "|                 ſ                  |\n\r"
   "|                  USART 첽ͨ                   |\n\r"
   "|                   www.kavirelectronic.ir                     |\n\r"
   "|                                               |\n\r"
   "|                      2011.5.15                        |\n\r"
   "|                ֧Ⱥ121939788                  |\n\r"
   "+-------------------------------------------------------+\n\r";
/*****************************************************************************
** : main
** : 
**   : Dream
** ա  : 20101206
*****************************************************************************/
int main(void)
{
	SystemInit();				// ϵͳʱãclock, PLL and Flash configuration
	NVIC_Configuration();		// ϵͳж
	LED_GPIO_Configuration();		// LED
	USART_Configuration();		// 
	LCD_Init();	
	USART_Send_Str(menu);
	USART_Send_Enter();	
	USART_Put_Inf("QQȺ",121939788);
 	USART_Put_Num(1234567890);
	USART_Send_Enter();
	LCD_Clear(BLUE);
  	while(1) 
	{		 
		switch(x)
		{
			case 0:LCD_Clear(WHITE);break;
			case 1:LCD_Clear(BLACK);break;
			case 2:LCD_Clear(RED);break;
			case 3:LCD_Clear(GREEN);break;
			case 4:LCD_Clear(BLUE);break;
			case 5:LCD_Clear(YELLOW);break;
			case 6:LCD_Clear(NAVY);break;
			case 7:LCD_Clear(OLIVE);break;
			case 8:LCD_Clear(MAGENTA);break;
			case 9:LCD_Clear(0x532e);break;
			case 10:LCD_Clear(0x42e0);break;
			case 11:LCD_Clear(0xad68);break;
		}	   		    					 
	    x++;
		if(x==12)x=0; 
		LED1=!LED1;					 
		Delay_Ms(1000);	
	}
}
/*****************************************************************************
** : GPIO_Configuration
** : IO(LED)
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LED_GPIO_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
						 RCC_APB2Periph_GPIOE | RCC_APB2Periph_USART1,ENABLE);	/* ʹܸ˿ʱӣҪ*/ 
	
	/* Configure IO connected to LD1, LD2 and LD3  leds *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_12 | GPIO_Pin_13;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOD, &GPIO_InitStructure);

	/* Configure IO connected to KEY1 *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOC, &GPIO_InitStructure);

   	/* Configure USART1 Tx (PA9) as alternate function push-pull */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);
    
  	/* Configure USART1 Rx (PA10) as input floating */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Configure IO connected to  *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOE, &GPIO_InitStructure);
	KEY= KEY_SEN= KEY_DOWN= KEY_LEFT= KEY_RIGHT= KEY_UP= 1;
}
/******************************************************************************
** : NVIC_Configuration
** : ϵͳж
**   : Dream
** ա  : 2011514
*****************************************************************************/
void NVIC_Configuration(void)
{
  	NVIC_InitTypeDef NVIC_InitStructure; 	
	#ifdef  VECT_TAB_RAM  
	  /* Set the Vector Table base location at 0x20000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
	#else  /* VECT_TAB_FLASH  */
	  /* Set the Vector Table base location at 0x08000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
	#endif
	/*  ͷж */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ȼ:ռȼ1λ,ȼ3λ
   	NVIC_InitStructure.NVIC_IRQChannel = EXTI3_IRQn;
   	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
   	NVIC_InitStructure.NVIC_IRQChannelSubPriority =2;
   	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
   	NVIC_Init(&NVIC_InitStructure);

	NVIC_InitStructure.NVIC_IRQChannel = SDIO_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority =1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}
/*****************************************************************************
** : Delay_Ms_Ms
** : ʱ1MS
				time (ms) 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Delay_Ms(uint16_t time)  //msʱ
{ 
	uint16_t i,j;
	for(i=0;i<time;i++)
  		for(j=0;j<10260;j++);
}
/*****************************************************************************
** : Delay_Ms_Us
** : ʱ1us
				time (us) 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Delay_Us(uint16_t time)  //usʱ
{ 
	uint16_t i,j;
	for(i=0;i<time;i++)
  		for(j=0;j<9;j++);
}
#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/*********************************************************************************************************
** End of File
*********************************************************************************************************/
